require "chifoodinspect/version"
require "soda/client"

module Chifoodinspect
  class Dataset
    attr_accessor :results

    def initialize ds_token=''
      @client = SODA::Client.new({domain: 'data.cityofchicago.org', app_token: ds_token})
      @ds = "cwig-ma7x"
    end

    def query hash={}
      @results = @client.get(@ds, hash)
      self
    end

    def query_local lat, lng, radius
      hash = {"$where" => "within_circle(location, #{lat}, #{lng}, #{radius})"}
      @results = @client.get(@ds, hash)
      self
    end

    def print
      @results.each do |r|
        puts "#{r.dba_name} \n\n"
        puts "#{r.risk} \n\n"
        puts "#{r.result} \n\n"
        puts "#{r.violations} \n\n"
      end
    end

    def write_to_file filename
      File.open(filename, "w") do |file|
        @results.each do |r|
          file.write("#{r.dba_name} || #{r.risk} || #{r.results}\n\n #{r.violations}\n\n")
        end
      end
    end

  end
end
